@ECHO OFF
ECHO. MAKING GRAPHICS

..\..\cnvrtrs\hackit map.bmp
..\..\cnvrtrs\raw-tile map.raw 32 32 char.tmp charmap.tmp

..\..\cnvrtrs\pal-gba map.pal pal1.tmp

copy palhead.txt pal.tmp
..\..\cnvrtrs\append pal.tmp pal1.tmp
..\..\cnvrtrs\append pal.tmp tail.txt
copy pal.tmp paldata.h


copy charhead.txt chardata.tmp
..\..\cnvrtrs\append chardata.tmp char.tmp
..\..\cnvrtrs\append chardata.tmp tail.txt
copy chardata.tmp chardata.h

copy maphead.txt mapdata.tmp
..\..\cnvrtrs\append mapdata.tmp charmap.tmp
..\..\cnvrtrs\append mapdata.tmp tail.txt
copy mapdata.tmp mapdata.h

del *.tmp
del *.raw
del *.pal

ECHO. MAKING ROM

zarmasm -CPU ARM7TDMI -Littleend thumb.asm
tcc     -c -Wall -Otime -ansic -fpu none -Littleend -cpu ARM7TDMI -apcs /narrow/noswst demo.c -o demo.o
zarmlink -bin -first thumb.o thumb.o demo.o -map -ro-base 0x080000C0 -rw-base 0x03000000 -o demo.agb

del *.o
copy ..\header.bin demo.gba
..\..\cnvrtrs\append demo.gba demo.agb
del demo.agb
