//GBA - background control header
//by dancotter@optushome.com.au

void txtbgsize256x256(vu16* background)
{
*background &= 0x3FFF;
}

void txtbgsize512x256(vu16* background)
{
*background |= 0x4000;
*background &= 0x7FFF;
}

void txtbgsize256x512(vu16* background)
{
*background |= 0x8000;
*background &= 0xBFFF;
}

void txtbgsize512x512(vu16* background)
{
*background |= 0xC000;
}

void rsbgsize128x128(vu16* background)
{
*background &= 0x3FFF;
}

void rsbgsize256x256(vu16* background)
{
*background |= 0x4000;
*background &= 0x7FFF;
}

void rsbgsize512x512(vu16* background)
{
*background |= 0x8000;
*background &= 0xBFFF;
}

void rsbgsize1024x1024(vu16* background)
{
*background |= 0xC000;
}

void bgscrnbaseblock(vu16* background,u16 baseblock)
{
baseblock<<=8;
*background |= baseblock;
*background &= (baseblock+0xE0FF);
}

void rsbgtransparent(vu16* background)
{
*background &= ~BIT13;
}

void rsbgwraparound(vu16* background)
{
*background |= BIT13;
}

void bg256x1col(vu16* background)
{
*background |= BIT7;
}

void bg16x16col(vu16* background)
{
*background &= ~BIT7;
}

void bgmosaicon(vu16* background)
{
*background |= BIT6;
}

void bgmosaicoff(vu16* background)
{
*background &= BIT6;
}

void bgcharbaseblock(vu16* background,u16 baseblock)
{
baseblock<<=2;
*background |= baseblock;
*background &= (baseblock+0xFFF3);
}

void bgpriority(vu16* background,u16 pr)
{
*background |= pr;
*background &= (pr + 0xFFFC);
}

void scrollbg0(u16 x, u16 y)
{
REG_BG0HOFS = x;
REG_BG0VOFS = y;
}

void scrollbg1(u16 x, u16 y)
{
REG_BG1HOFS = x;
REG_BG1VOFS = y;
}

void scrollbg2(u16 x, u16 y)
{
REG_BG2HOFS = x;
REG_BG2VOFS = y;
}

void scrollbg3(u16 x, u16 y)
{
REG_BG3HOFS = x;
REG_BG3VOFS = y;
}

