//GBA Display Control Header
//by dancotter@optushome.com.au

void forceblankoff(void)
        {
        REG_DISPCNT &= ~BIT7;
        }

void forceblankon(void)
        {
        REG_DISPCNT |= BIT7;
        }

void background0on(void)
	{
	REG_DISPCNT |= BIT8;
	}

void background1on(void)
	{
	REG_DISPCNT |= BIT9;
	}


void background2on(void)
	{
	REG_DISPCNT |= BIT10;
	}


void background3on(void)
	{
	REG_DISPCNT |= BIT11;
	}


void objectson(void)
	{
	REG_DISPCNT |= BIT12;
	}


void background0off(void)
	{
	REG_DISPCNT &= ~BIT8;
	}


void background1off(void)
	{
	REG_DISPCNT &= ~BIT9;
	}


void background2off(void)
	{
	REG_DISPCNT &= ~BIT10;
	}


void background3off(void)
	{
	REG_DISPCNT &= ~BIT11;
	}


void objectsoff(void)
	{
	REG_DISPCNT &= ~BIT12;
	}

void mode0(void)
	{
	REG_DISPCNT &= 0xFFF8;
	}

void mode1(void)
	{
	REG_DISPCNT |= 0x0001;
	REG_DISPCNT &= 0xFFF9;
	}

void mode2(void)
	{
	REG_DISPCNT |= 0x0002;
	REG_DISPCNT &= 0xFFFA;
	}

void mode3(void)
	{
	REG_DISPCNT |= 0x0003;
	REG_DISPCNT &= 0xFFFB;
	}

void mode4(void)
	{
	REG_DISPCNT |= 0x0004;
	REG_DISPCNT &= 0xFFFC;
	}

void mode5(void)
	{
	REG_DISPCNT |= 0x0005;
	REG_DISPCNT &= 0xFFFD;
	}


void bg_mosaic_v_size(u16 size)
{
size<<=12;
REG_MOSAIC |= size;
REG_MOSAIC &= (size+0x0FFF);
}

void bg_mosaic_h_size(u16 size)
{
size<<=8;
REG_MOSAIC |= size;
REG_MOSAIC &= (size+0xF0FF);
}

void obj_mosaic_v_size(u16 size)
{
size<<=4;
REG_MOSAIC |= size;
REG_MOSAIC &= (size+0xFF0F);
}

void obj_mosaic_h_size(u16 size)
{
REG_MOSAIC |= size;
REG_MOSAIC &= (size+0xFFF0);
}

void obj_1d_mapping(void)
{
	REG_DISPCNT|= BIT6;
}

void obj_2d_mapping(void)
{
	REG_DISPCNT&= ~BIT6;
}



