//GBA Rotation Scaling Header
//by dancotter@optushome.com.au

cs32 cos_f[4] =
{
0x100 ,
0x0   ,
0xffffff01,
0x0 
};

cs32 sin_f[4] =
{
0x0   ,
0x100 ,
0x0   ,
0xffffff01
};

//rs_bg2(0,xcen,ycen,xoff-xcen,yoff-ycen,0x100,0x100);
void rs_bg2(s32 angle,s32 rotate_x, s32 rotate_y,s32 scroll_x,s32
scroll_y, s32 zoomx, s32 zoomy)
{

//rotate_x and y are the centers for rotation

rotate_y = ((rotate_y )) * zoomx>>8;   //correct center for zoom
rotate_x = ((rotate_x )) * zoomy>>8;
REG_BG2X = (((scroll_x))-rotate_y*sin_f[angle]-rotate_x*cos_f[angle]);
REG_BG2Y = (((scroll_y))-rotate_y*cos_f[angle]+rotate_x*sin_f[angle]);


 REG_BG2PA = (cos_f[angle]*zoomx)>>8;  //cos&sin are LUTs that are .8 fixed numbers
 REG_BG2PB = (sin_f[angle]*zoomx)>>8;  //zoom is also fixed
 REG_BG2PC = (-sin_f[angle]*zoomy)>>8;
 REG_BG2PD = (cos_f[angle]*zoomy)>>8;

}

void rs_bg3(s32 angle,s32 rotate_x, s32 rotate_y,s32 scroll_x,s32
scroll_y, s32 zoomx, s32 zoomy)
{

//rotate_x and y are the centers for rotation

rotate_y = ((rotate_y )) * zoomx>>8;   //correct center for zoom
rotate_x = ((rotate_x )) * zoomy>>8;
REG_BG3X = (((scroll_x))-rotate_y*sin_f[angle]-rotate_x*cos_f[angle]);
REG_BG3Y = (((scroll_y))-rotate_y*cos_f[angle]+rotate_x*sin_f[angle]);


 REG_BG3PA = (cos_f[angle]*zoomx)>>8;  //cos&sin are LUTs that are .8 fixed numbers
 REG_BG3PB = (sin_f[angle]*zoomx)>>8;  //zoom is also fixed
 REG_BG3PC = (-sin_f[angle]*zoomy)>>8;
 REG_BG3PD = (cos_f[angle]*zoomy)>>8;

}


void rs_sprite(u8 group, s32 angle, s32 zoomx, s32 zoomy)
{
u16 *vram = &MEM_OAM;
vram+=(group << 4) + 3;
*vram = (cos_f[angle]*zoomx)>>8;
vram+=4;
*vram = (sin_f[angle]*zoomx)>>8;
vram+=4;
*vram = (-sin_f[angle]*zoomy)>>8;
vram+=4;
*vram = (cos_f[angle]*zoomy)>>8;
}


