//GBA video ram load header
//by dancotter@optushome.com.au

void loadscreendatatxt(u16 baseblock,cu16 *screendata, u32 amount)
{
u32 i=0;
u16 *vram = &BB_screen0;
vram+= (BB_screen * baseblock)>>1;
do
	{
   *vram = *screendata;
   vram++;
   screendata++;
   i++;
   }
while(i<amount);
}

void loadscreendatars(u16 baseblock,cu8 *screendata, u32 amount)
{
u32 i=0;
u16 data=0;
u16 *vram = &*(u16*)0x06000000;
vram+= (BB_screen * baseblock)>>1;
do
	{
   data = *screendata;
   screendata++;
   data|=(*screendata<<8);
   *vram = data;
   vram++;
   screendata++;
   i+=2;
   }
while(i<amount);
}


void loadchardata(u16 baseblock, cu8 *chardata, u32 amount)
{
u32 i=0;
u16 data=0;
u16 *vram = &BB_char0;
vram+= (BB_char * baseblock) >> 1;
do
	{
   data = *chardata;
   chardata++;
   data |= (*chardata<<8);
   *vram = data;
   vram++;
   chardata++;
   i+=2;
	}
while(i<amount);
}

void loadobjchardata(cu8 *chardata, u32 amount, u32 offset)
{
u32 i=0;
u16 data=0;
u16 *vram = &MEM_OBJDATAL;
vram+=offset>>1;
do
	{
   data = *chardata;
   chardata++;
   data|=(*chardata<<8);
   *vram=data;
   vram++;
   chardata++;
   i+=2;
   }
while(i<amount);
}

void loadobjchardatah(cu8 *chardata, u32 amount, u32 offset)
{
u32 i=0;
u16 data=0;
u16 *vram = &MEM_OBJDATAH;
vram+=offset>>1;
do
	{
   data = *chardata;
   chardata++;
   data|=(*chardata<<8);
   *vram=data;
   vram++;
   chardata++;
   i+=2;
   }
while(i<amount);
}

void loadchardata2b(u16 baseblock, cu8 *chardata, u32 amount)
{
u32 i=0;
u16 data=0;
u16 *vram = &BB_char0;
u8 cx[8];
u8 j;
amount>>=3;
vram+= (BB_char * baseblock) >> 1;
do
	{
   for(j=0;j<8;j++)
   	{
		cx[j] = *chardata;
   	cx[j]&=1<<j;
	   if(cx[j] > 0) cx[j] = 0xFF;
   	}

   for(j=0;j<8;j+=2)
   	{
      data=cx[j];
      data|=(cx[j+1]<<8);
      *vram = data;
      vram++;
      }

   chardata++;
   i++;
   
	}
while(i<amount);
}
