//By dancotter@optushome.com.au, color change demo
//this was my first ever gba demo
//this demo does not use the gba C library because i had not
//yet written it.
//this demo shows a single color on the whole screen and changes this color
//through out the color spectrum


typedef volatile unsigned int vu16;//typedefs
typedef unsigned int u16;

#define DISPCNT *(vu16*)0x04000000//registers used
#define DISPSTAT *(vu16*)0x04000004
#define VCOUNT *(vu16*)0x04000006


u16 red=31,blue=0,green=0,i,j,*vram=&*(u16*)0x06000000,*pal=&*(u16*)0x05000000;
//variables

void setpal(void){*pal=((red)|(green<<5)|(blue<<10));}
//set the palette color

void wait(void)
{if((DISPSTAT&1)==1)while((DISPSTAT&1)==1);
 while((DISPSTAT&1)==0);
}//wait for vblank

void AGBMain()
{for(i=0;i<19200;i++) vram[i]=0x0000;//clear screen
 setpal();//set color
 DISPCNT = 0x404;//turn on background and set mode
 while(1)//loop forever
 {for(j=0;j<6;j++)//6 passes
  {for(i=0;i<31;i++)//31 steps per color element
   {if(j==0)green++;
    else if(j==1)red--;
    else if(j==2)blue++;
    else if(j==3)green--;  //change color for
    else if(j==4)red++;    //appropriate pass
    else if(j==5)blue--;
    wait();//wait for vertical blank
    setpal();//set color
   }
  }
 }
}
