//
// Buffer Demo
//
// by dancotter@optushome.com.au
//
//This is a really simple demo
//This demo uses the two video buffers in mode 5 to quickly switch between
//two 32768 color images really really fast (switches each v-blank).

//the 2 images are high color images saved in RAW format using paint shop pro

//includes:
#include "..\..\lib\gba.h" //gameboy advance header file with all the functions it calls
#include "picdata.h" //info of pictures

void AGBMain()
	{
		//set video mode to 5
		mode5();

      //loadbuffer0 with picture data
		m5_loadbuffer(picdata,0);

      //loadbuffer1 with next pictures data
      m5_loadbuffer(picdata+20480,1);
      //the next pictures data starts at array element 160*128 = 20480

      forceblankoff();
      //turn on the screen

		//turn background2 on (background 2 is the only one which is used
      //in mode 5).
		background2on();

      //loop forever....
		while(!0)
			{
            wait_vbl_start(1);//wait for vertical blank to start once
            //if this is not done the buffer will be switched before the image
            //has been drawn.
            //to slow the switching time, make it wait for more vbl's
            //eg use wait_vbl_start(5); to make it 5 times slower.
            //there are roughly 60 vertical blanks per second.

            switchbuffer();//switch which buffer is being shown

			}
	}
