//GBA interrupt Header
//by dancotter@optushome.com.au
#define I_GAMEPAK BIT13
#define I_KEY     BIT12
#define I_DMA3    BIT11
#define I_DMA2    BIT10
#define I_DMA1    BIT9
#define I_DMA0    BIT8
#define I_COM     BIT7
#define I_TIMER3  BIT6
#define I_TIMER2  BIT5
#define I_TIMER1  BIT4
#define I_TIMER0  BIT3
#define I_VCOUNT  BIT2
#define I_HBLANK  BIT1
#define I_VBLANK  BIT0

void disableinterrupts(void)
	{
	REG_IME = 0;
	}

void enableinterrupts(void)
	{
	REG_IME = 1;
	}

void set_ie(u16 flags)
	{
   REG_IE = 0;
   REG_IE = flags;
   }

void reset_if(u16 flags)
	{
   REG_IF = flags;
   }

