//GBA Joypad Header File
//by dancotter@optushome.com.au

//Joypad:
#define J_A      BIT0
#define J_B      BIT1
#define J_SELECT BIT2
#define J_START  BIT3
#define J_RIGHT  BIT4
#define J_LEFT   BIT5
#define J_UP     BIT6
#define J_DOWN   BIT7
#define J_R      BIT8
#define J_L      BIT9
#define JOYPAD   *(volatile unsigned short*)0x04000130


//==============================
//JOYPAD FUNCTIONS
//==============================

void wait_pad_up(void)
	{
	while((REG_KEYINPUT & 1023) != 1023);
	}

void wait_pad_down(void)
	{
   while((REG_KEYINPUT & 1023) == 1023);
   }

void wait_pad(u16 buttons)
	{
   while((REG_KEYINPUT & 1023) != (~(buttons) & 1023));
   }

u16 pad(u16 buttons)
	{
   if((REG_KEYINPUT & 1023) == (~(buttons) & 1023)) return 1;
   else return 0;
   }


