//GBA Mode 4 Header File
//by dancotter@optushome.com.au


void m4_put_bg_2pixel(u16 x, u16 y, u8 color1, u8 color2, u8 buffer)
	{
	u16 *pal;
   u16 color = color1;
   color = (color2<<8)+color1;
	if(buffer == 1) pal = &MEM_VBUFFER1;
	else pal = &MEM_VBUFFER0;
	pal+=((y * 120) + (x>>1));
	*pal=color;
	}

u8 m4_get_bg_pixel(u16 x, u16 y, u8 buffer)
	{
 	u16 *pal;
   u16 color;
   u16 colorr=0;
   if(buffer == 1) pal = &MEM_VBUFFER1;
	else pal = &MEM_VBUFFER0;
   pal+=((y * 120) + (x>>1));
   color = *pal;
   if((x & 0x01) == 1) color=(color& 0xFF00)>>8;
   else color = (color & 0x00FF);
   colorr+= color;
   return colorr;
	}

void m4_put_pixel(u16 x ,u16 y,u8 color,u8 buffer)
	{
   u8 color2;
   if((x & 1) == 1)
   	{
      color2 = m4_get_bg_pixel(x-1,y,buffer);
      m4_put_bg_2pixel(x-1, y, color2, color, buffer);
      }
   else
   	{
      color2 = m4_get_bg_pixel(x+1,y,buffer);
      m4_put_bg_2pixel(x, y, color, color2, buffer);
      }
	}



void m4_loadbuffer(const u16 *data, u8 buffer)
	{
	u16 i=0;
	u16 *buf;
	if(buffer==0) buf = &MEM_VBUFFER0;
	else buf = &MEM_VBUFFER1;
	do
		{
		buf[i] = data[i];
		i++;
		}
	while(i<19200);
	}

